<?PHP

/*
* Retourne une liste de choix avec les modeles de taches
*/
function getSelectAllModels($dossier_xml_tache,$cleASelectionner){
$dossier_tache = @opendir("./".$dossier_xml_tache);
$chaine="<select name='modeleTache'>";
while (( ($fichier = readdir($dossier_tache)) ) != false)
{
	if(!is_file($fichier)){
	
	if ($fichier != '.' && $fichier != '..')
	{
		// fichier est un dossier contenant les donnees d'un modele de tache.
		// On lit les infos dans le fichier xml/tache/$fichier/tache.xml pour en savoir plus sur le modele de tache.
		$fichier_xml = simplexml_load_file("./".$dossier_xml_tache.'/'.$fichier.'/tache.xml');

		$tache = $fichier;
		$titre = (string)$fichier_xml->titre;
		$description = (string)$fichier_xml->description;

		$chaine.="<option value='".$tache."'";
		if($tache==$cleASelectionner)
			$chaine.=" selected='selected'";
		$chaine.=">".$tache." ".$titre."</option>";
	}
	}
}
$chaine.="</select>";
closedir($dossier_tache);
return $chaine;
}


/*
* Retrouve le Titre du modele a partir de son numero
*/
function getTitreModele($dossier_xml_tache,$numModele){
$titre="";
if (file_exists('./'.$dossier_xml_tache.'/'.$numModele.'/tache.xml')){	
	$fichier_xml = simplexml_load_file('./'.$dossier_xml_tache.'/'.$numModele.'/tache.xml');
	$titre = (string)$fichier_xml->titre;
}
return $titre;
}





/*
* Parcours de l'arbre de tache
* Entree : 
*	$sxml : Noeud de l'arbre XML
*	$indent : Entier permettant de decaler l'affichage pour les sous taches
*	$adminEdit : Permet d'afficher les boutons Modifier et Supprimer
*/
function parcourir($sxml,$indent,$adminEdit){

$indent=$indent+1;
  //Acces aux enfants de l'element courant
  foreach($sxml->children() as $element){
		
	if($element->id!=''){
		echo "\n<tr>\n<td>";
		for($i=1;$i<$indent;$i++){
			echo "+...";
		}
	
		echo "".$element->id." : ".$element->nom." (".$element->description.") </td>";

		if($adminEdit==1){
			echo "\n<div class='button'>";

			echo "\n<td><form name='modifTache' method='POST' action='".$_SERVER['PHP_SELF']."?".$_SERVER["QUERY_STRING"]."'><input type='hidden' name='modeleTache' value='".$_SESSION['modeleTache']."' /><input type='hidden' name='idTache' value='".$element->id."' /><input type='hidden' name='adminEdit' value='1' /><input type='submit' name='modifier' value='modifier'/></form></td>\n";


			// Lance directement la suppression de la tache
			echo "\n<td><form name='supprTache' method='POST' onSubmit=\"javascript:return confirm('Voulez vous vraiment supprimer cette tache et les sous-taches associees?');\" action='./ModeleTache/tache_editTache.php'><input type='hidden' name='modeleTache' value='".$_SESSION['modeleTache']."' /><input type='hidden' name='idTache' value='".$element->id."' /><input type='submit' name='supprimer' value='supprimer' /></form></td>\n";
			echo "\n</div>";
		}
		echo " \n</tr>";
	}
	
      parcourir($element,$indent,$adminEdit);
  }
}






// fonction rechercher_tache renvoie le noeud associe a un identifiant
function rechercher_tache($sxml,$idRecherche,&$resultat_recherche){

  //Acces aux enfants de l'element courant
  foreach($sxml->children() as $element){
	
	if($element->id!='' && $element->id==$idRecherche){
		$resultat_recherche=$element;
		return 0;
	}
	
 	rechercher_tache($element,$idRecherche,$resultat_recherche);     
  }
}



// fonction rechercher_tache_pere renvoie le noeud pere associe a un identifiant
function rechercher_tache_pere($sxml,$idRecherche,&$element_pere){

  //Acces aux enfants de l'element courant
  foreach($sxml->children() as $element){
	
	if($element->id!='' && $element->id==$idRecherche){
		$element_pere=$sxml;
	}
	
 	rechercher_tache_pere($element,$idRecherche,$element_pere);     
  }

}


/*
* Retourne la liste des taches du modele courant passe en parametres
* Entree : 
*	$sxml : Noeud de l'arbre XML
*	$indent : Entier permettant de decaler l'affichage pour les sous taches
*
* Entree et Sortie :
*	$tableauTache : Tableau contenant la liste des Taches (Tableau vide en entree)
*
*/
function getListeTache($sxml,$indent,&$tableauTache){

$indent=$indent+1;
  //Acces aux enfants de l'element courant
  foreach($sxml->children() as $element){
	
	if($element->id!=''){
		$tableauTache["$element->id"]['indentation']=$indent;
		$tableauTache["$element->id"]['nom']=$element->nom;
	}
      getListeTache($element,$indent,$tableauTache);
  }
}


function getSelectListeTache($dossier_xml_tache,$modeleTache,$cleASelectionner,$choixAucune,$fonctionJS)
{

	echo "\n<select id='sTache' name='sTache' onchange='javascript:".$fonctionJS."'>";

	if($choixAucune==1)
	echo "\n\t<option value='Aucune'>Aucune</option>";
	
	
	$fichier='./'.$dossier_xml_tache.'/'.$modeleTache.'/tache.xml';
	
	if(is_file($fichier)){
		$fichier_xml = simplexml_load_file($fichier);
					
		$tableauTache=array();			
		getListeTache($fichier_xml,0,$tableauTache);
		foreach($tableauTache as $key=>$valeur){
			echo "\n\t<option value='".$key."' ";

			if($key==$cleASelectionner)
				echo "selected='selected'";

			echo ">";
			for ($i=1;$i<$valeur['indentation'];$i++)
				echo "...";
				echo $key." - ".$valeur['nom']."</option>";
			
		}
		echo "\n</select>";
	}

}


/*
* Fonction getListeIdTache
*	entree : sxml : noeud d'un fichier SimpleXml
*	entree et sortie : tableauIdTache : Tableau contenant la liste des identifiants 
*       des sous tache du noeud
*/



function getListeIdTache($sxml,&$tableauIdTache){

  //Acces aux enfants de l'element courant
  foreach($sxml->children() as $element){
	
	if($element->id!=''){
		$tableauIdTache[]=$element->id;
	}
      getListeIdTache($element,$tableauIdTache);
  }
}



function getNumTachePere($sxml,$idTache) {
	$i=0;
	//Acces aux enfants de l'element courant
  	foreach($sxml->task as $element){
		if($element->id!=''){
			
			if($element->id==$idTache){
				return $i;
			}
			$i++;
		}
  	}
	return 0;
}

?>
