<?php
include("../config.inc.php");
include("./metier_functions.inc.php");
include("../common_functions.inc.php");


/* Cette page gere les requetes envoyees avec Ajax depuis la page d'edition de QCM. */
/* Donnees reaues, a enregistrer dans le fichier qcm.xml.
Les donnees sont envoyees en POST et qe ou qs est le numero de la question.
Si qe et envoye, on modifie ou on ajoute une question au qcm, alors que si qs est envoye, on supprime cette question. */



if (isset($_POST['qe']) && isset($_POST['qcm']))
{
	$dossier='../'.$dossier_xml_qcm.'/'.$_POST['qcm'];

	// on recupere les donnees envoyees.
	$nbq = (int)$_POST['qe'];
	
	$tache = $_POST['sTache'];
	$question = $_POST['question'];
	$image = $_POST['image'];
	$explic = $_POST['explic'];
	$typeQuestion = $_POST['typeQuestion'];
	$nb_rep = $_POST['nbrep'];


	// Si il n'y a pas d'image, elle a pu atre enlevee, il faut donc dedruire l'eventuel fichier envoye avant que l'utilisateur decoche la case image.
	if ($image == '') del_img($dossier_xml_qcm,$_SESSION['qcm'], $nbq);

	$fichier_xml = @simplexml_load_file($dossier.'/qcm.xml');

	if (!isset($fichier_xml->question[$nbq]))
	{
		// La question n'existe pas encore, on l'ajoute au qcm.
		$fichier_xml->addChild('question');
		$fichier_xml->question[$nbq]->addChild('q');
		$fichier_xml->question[$nbq]->addChild('image');
		$fichier_xml->question[$nbq]->addChild('explic');
		$fichier_xml->question[$nbq]->addChild('typeQuestion');
		$fichier_xml->question[$nbq]->addChild('reponses');
	}

	// On remplie la question avec les donnees envoyees. La fonction encode permet de supprimer les caracteres speciaux des chaanes
	// de caracteres (< > " & ...), afin qu'elles puissent atre enregistrees dans le fichier xml.
	$qxml = $fichier_xml->question[$nbq];
	$qxml->idTache = encode($tache);
	$qxml->q = encode($question);
	$qxml->image = $image;
	$qxml->explic = encode($explic);
	$qxml->typeQuestion = encode($typeQuestion);

	// Le nombre des reponses pouvant varier, on supprime toutes les reponses puis on les re-enregistre toutes de nouveau.
	unset($qxml->reponses);
	$qxml->addChild('reponses');
	for ($i = 0; $i < $nb_rep; $i ++)
	{
		$qxml->reponses->addChild('rep');
		$qxml->reponses->rep[$i] = encode($_POST['rep'.$i]);
		if ($_POST['bonne_rep'.$i] == 'vrai') 
			$qxml->reponses->rep[$i]->addAttribute('bonne', 'vrai');
		else 
			$qxml->reponses->rep[$i]->addAttribute('bonne', 'faux');
	}

	// Enregistrement du qcm modifie dans le fichier qcm.xml.
	$f = fopen($dossier.'/qcm.xml', 'w');
	fwrite($f, $fichier_xml->asXML());
	fclose($f);
}


elseif (isset($_POST['qs']) && isset($_POST['qcm']))
{
	$dossier='../'.$dossier_xml_qcm.'/'.$_POST['qcm'];

	// On supprime simplement la qs eme question du qcm.
	$nbq = (int)$_POST['qs'];
	$fichier_xml = @simplexml_load_file($dossier.'/qcm.xml');

	unset($fichier_xml->question[$nbq]);

	$f = fopen($dossier.'/qcm.xml', 'w');
	fwrite($f, $fichier_xml->asXML());
	fclose($f);

	// Si une image etait attachee a la question, on la supprime egalement.
	del_img($dossier_xml_qcm,$_SESSION['qcm'], (int)$_POST['qs']);
}



/* Donnees envoyees.
Apres avoir recu et sauvegarder les donnees d'une question, cette page peut envoyer les donnees d'une question au script cate client.
Ainsi, en un appel a cette page, le script cote client peut sauvegarder une question, et afficher les donnees de la question suivante.
Le numero de la question dont il faut envoyer les donnees est contenu dans la variable q.
Les donnees seront envoyer sous la forme d'un fichier xml. Si le client ne demande pas de donnees ($_POST['q'] n'existe pas),on renvoie un fichier xml vide. */
if (isset($_POST['q']) && isset($_POST['qcm']))
{

	$dossier='../'.$dossier_xml_qcm.'/'.$_POST['qcm'];


	$nbq = '0';
	$tache='';
	$q = '';
	$image = '';
	$explic = '';
	$typeQuestion = '';
	$reponses = '';

	// on recherche les donnees correspondant a la question voulue.
	$fichier_xml = @simplexml_load_file($dossier.'/qcm.xml');

	// On envoie egalement a chaque fois le nombre de questions dans le QCM.
	// Cela permet au client d'afficher "Question XX/XX".
	$nbq = count($fichier_xml->question);
	if (isset($fichier_xml->question[(int)$_POST['q']]))
	{
		$qxml = $fichier_xml->question[(int)$_POST['q']];

		if (isset($qxml->idTache)) $tache = encode((string)$qxml->idTache);
		if (isset($qxml->q)) $q = encode((string)$qxml->q);
		if (isset($qxml->image)) $image = (string)$qxml->image;
		if (isset($qxml->explic)) $explic = encode((string)$qxml->explic);
		if (isset($qxml->typeQuestion)) $typeQuestion = encode((string)$qxml->typeQuestion);
		foreach ($qxml->reponses->rep as $rep) 
			$reponses .= '<rep bonne="'.(string)$rep['bonne'].'">'.encode((string)$rep).'</rep>';
	}


	/* Debug
	$g = fopen('./qcmdebug.txt', 'w');
	$test=$_POST['qcm'];
	$test.=$fichier_xml->asXML();
	fwrite($g, $test);
	fclose($g);
	*/
	
	// Envoie du fichier XML.
	header("Content-Type: text/xml");
	$xml = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
	$xml .= '<reponse nbq="'.$nbq.'"><idTache>'.$tache.'</idTache><q>'.$q.'</q><image>'.$image.'</image><explic>'.$explic.'</explic><typeQuestion>'.$typeQuestion.'</typeQuestion><reponses>'.$reponses.'</reponses></reponse>';
	echo $xml;
	
}
else
{
	@header("Content-Type: text/xml");
	echo '<?xml version="1.0" encoding="UTF-8" ?>'."\n".'<reponse></reponse>';
}
?>